## reproc 14.2.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.21)

project(
  reproc
  VERSION 14.2.4
  DESCRIPTION "Cross-platform C99/C++11 process library"
  HOMEPAGE_URL "https://github.com/DaanDeMeyer/reproc"
  LANGUAGES C
)

# Common options and functions separated for easier reuse in other projects.
include(cmake/reproc.cmake)

option(REPROC++ "Build reproc++" ${REPROC_DEVELOP})
option(
  REPROC_MULTITHREADED
  "Use `pthread_sigmask` and link against the system's thread library"
  ON
)

if(REPROC_MULTITHREADED)
  set(THREADS_PREFER_PTHREAD_FLAG ON)
  find_package(Threads REQUIRED)
  set(REPROC_THREAD_LIBRARY ${CMAKE_THREAD_LIBS_INIT})
endif()

add_subdirectory(reproc)

if(REPROC++)
  enable_language(CXX)
  add_subdirectory(reproc++)
endif()

=== reproc++/CMakeLists.txt ===
reproc_library(reproc++ CXX)

target_link_libraries(reproc++ PRIVATE
  reproc
  $<$<BOOL:${REPROC_MULTITHREADED}>:Threads::Threads>
)

target_sources(
  reproc++
  PRIVATE src/reproc.cpp
  # We manually propagate reproc's object files until CMake adds support for
  # doing it automatically.
  INTERFACE $<$<BOOL:${REPROC_OBJECT_LIBRARIES}>:$<TARGET_OBJECTS:reproc>>
)

reproc_example(reproc++ drain CXX)
reproc_example(reproc++ forward CXX)
reproc_example(reproc++ run CXX)

if(REPROC_MULTITHREADED)
  reproc_example(reproc++ background CXX DEPENDS Threads::Threads)
endif()

=== reproc/CMakeLists.txt ===
if(WIN32)
  set(REPROC_WINSOCK_LIBRARY ws2_32)
elseif(CMAKE_SYSTEM_NAME MATCHES Linux)
  set(REPROC_RT_LIBRARY rt) # clock_gettime
endif()

reproc_library(reproc C)

if(REPROC_MULTITHREADED)
  target_compile_definitions(reproc PRIVATE REPROC_MULTITHREADED)
  target_link_libraries(reproc PRIVATE Threads::Threads)
endif()

if(WIN32)
  set(PLATFORM windows)
  target_compile_definitions(reproc PRIVATE WIN32_LEAN_AND_MEAN)
  target_link_libraries(reproc PRIVATE ${REPROC_WINSOCK_LIBRARY})
else()
  set(PLATFORM posix)
  if(NOT APPLE)
    target_link_libraries(reproc PRIVATE ${REPROC_RT_LIBRARY})
  endif()
endif()

target_sources(reproc PRIVATE
  src/clock.${PLATFORM}.c
  src/drain.c
  src/error.${PLATFORM}.c
  src/handle.${PLATFORM}.c
  src/init.${PLATFORM}.c
  src/options.c
  src/pipe.${PLATFORM}.c
  src/process.${PLATFORM}.c
  src/redirect.${PLATFORM}.c
  src/redirect.c
  src/reproc.c
  src/run.c
  src/strv.c
  src/utf.${PLATFORM}.c
)

reproc_test(reproc argv C)
reproc_test(reproc deadline C)
reproc_test(reproc env C)
reproc_test(reproc io C)
reproc_test(reproc overflow C)
reproc_test(reproc path C)
reproc_test(reproc stop C)
reproc_test(reproc working-directory C)
reproc_test(reproc pid C)

if(UNIX)
  reproc_test(reproc fork C)
endif()

reproc_example(reproc drain C)
reproc_example(reproc env C ARGS PROJECT=REPROC)
reproc_example(reproc path C)
reproc_example(reproc poll C)
reproc_example(reproc read C)
reproc_example(reproc parent C)
reproc_example(reproc run C)

=== debian/changelog ===
reproc (14.2.5-2) unstable; urgency=medium

  * Drop libreproc++14.symbols
  * Update lintian-overrides
  * Update Standards-Version

 -- Valentin Vidic <vvidic@debian.org>  Thu, 08 May 2025 22:59:14 +0200

reproc (14.2.5-1) unstable; urgency=medium

  * Initial release. (Closes: #1087394)

 -- Valentin Vidic <vvidic@debian.org>  Wed, 15 May 2024 01:01:01 +0200

=== debian/control ===
Source: reproc
Section: libs
Priority: optional
Maintainer: Valentin Vidic <vvidic@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.7.2
Homepage: https://github.com/DaanDeMeyer/reproc
Vcs-Browser: https://salsa.debian.org/debian/reproc
Vcs-Git: https://salsa.debian.org/debian/reproc.git

Package: libreproc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libreproc14 (= ${binary:Version}),
 libreproc++14 (= ${binary:Version}),
 ${misc:Depends},
Description: Cross-platform C99/C++11 process library (development files)
 reproc (Redirected Process) is a cross-platform C/C++ library that simplifies
 starting, stopping and communicating with external programs. The main use case
 is executing command line applications directly from C or C++ code and
 retrieving their output.
 .
 This package contains development files for reproc and reproc++.

Package: libreproc14
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Cross-platform C99/C++11 process library (C library)
 reproc (Redirected Process) is a cross-platform C/C++ library that simplifies
 starting, stopping and communicating with external programs. The main use case
 is executing command line applications directly from C or C++ code and
 retrieving their output.
 .
 This package contains the reproc C99 library for working with external
 programs.

Package: libreproc++14
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Cross-platform C99/C++11 process library (C++ library)
 reproc (Redirected Process) is a cross-platform C/C++ library that simplifies
 starting, stopping and communicating with external programs. The main use case
 is executing command line applications directly from C or C++ code and
 retrieving their output.
 .
 This package contains the reproc++ library that depends on reproc and adapts
 its API to an idiomatic C++11 API. It also adds a few extras that simplify
 working with external programs from C++.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/DaanDeMeyer/reproc/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
